import josx.platform.rcx.*;

public class LejWay
    implements SensorConstants, LCDConstants // [sic]
{
    public static void main (String[] args)
	throws InterruptedException
    {
	int kd = 220;
	int kp = 300;
	int ki = 11;
	int scale = 100000;

	int decayInt = 6;	// decay percentage of I per period
	int tDelta = 20;	// period in ms

	int offset = 2;
	
	Sensor s1 = Sensor.S1;
	s1.setTypeAndMode (SENSOR_TYPE_RAW, SENSOR_MODE_RAW);
	s1.activate();

	Sensor s3 = Sensor.S3;
	s3.setTypeAndMode (SENSOR_TYPE_RAW, SENSOR_MODE_RAW);
	s3.activate();

	int power = 7;
	Motor.A.setPower (power);
	Motor.C.setPower (power);

	Thread.sleep(20);

	int errorInt = 0;
	int errorOld = 0;

	Thread.sleep (200);
	
	int tNext = (int)System.currentTimeMillis() + tDelta;

	while (Button.RUN.isPressed()) {
	}
	while (!Button.RUN.isPressed()) {
	    int error = s1.readRawValue() - s3.readRawValue() - offset;
	    int errorDiff = error - errorOld;

	    errorInt += error - errorInt * decayInt / 100;
	    errorOld = error;
    
	    int pid = kd * errorDiff + kp * error + ki * errorInt;
    
	    // LCD.setNumber (LCD_SIGNED, error, LCD_DECIMAL_0);
	    // LCD.refresh();

	    int tOn = - pid * tDelta / scale;

	    if (tOn > 0) {
		Motor.A.forward();
		Motor.C.forward();
	    } else if (tOn < 0) {
		Motor.A.backward();
		Motor.C.backward();
	    } else {
		Motor.A.stop();
		Motor.C.stop();
	    }

	    int tEnd = (int)System.currentTimeMillis() + abs(tOn);
	    if (tEnd < tNext) {
		while ((int)System.currentTimeMillis() < tEnd) {
		    Thread.yield();
		}
		Motor.A.stop();
		Motor.C.stop();
	    }
	    while ((int)System.currentTimeMillis() < tNext) {
		Thread.yield();
	    }
	    tNext += tDelta;
	}
	while (Button.RUN.isPressed()) {
	}
	Motor.A.flt();
	Motor.C.flt();
    }

    private static int abs(int x) {
	return x < 0 ? -x : x;
    }

}
